﻿using Syncfusion.UI.Xaml.Grid;
using Syncfusion.UI.Xaml.Grid.Cells;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using Syncfusion.UI.Xaml.Grid.Helpers;
using System.Windows.Navigation;
using System.Windows.Shapes;

using Syncfusion.Data;
using System.Reflection;
using System.Diagnostics;
using Syncfusion.Data.Extensions;
using SfDataGridDemo;
using System.ComponentModel;

namespace SfDataGridDemo
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.sfdatagrid.CurrentCellBeginEdit += Sfdatagrid_CurrentCellBeginEdit;
            this.sfdatagrid.QueryRowHeight += sfdatagrid_QueryRowHeight;
        }

        private async void Sfdatagrid_CurrentCellBeginEdit(object sender, CurrentCellBeginEditEventArgs e)
        {
            Debug.WriteLine("Sfdatagrid_CurrentCellBeginEdit");
            await this.Dispatcher.BeginInvoke(new Action(() =>
            {
            int recordIndex = this.sfdatagrid.ResolveToRecordIndex(e.RowColumnIndex.RowIndex);

            var rowGenerator = this.sfdatagrid.GetRowGenerator() as RowGenerator;
            
               var columnElement= this.sfdatagrid.SelectionController.CurrentCellManager.CurrentCell.ColumnElement as GridCell;

                var rowData = columnElement.DataContext;

               var dataColumn = columnElement.ColumnBase as DataColumn;
                

                if (dataColumn.Renderer.GetType() == typeof(GridCellTemplateRenderer) && dataColumn.GridColumn.MappingName=="EmployeeId")
                {
                   
                    DataTemplate dataTemplate = null;
                    ComboBox comboBox = null;
                    ContentPresenter contentPresenter = this.FindVisualChild<ContentPresenter>(columnElement);

                    dataTemplate = contentPresenter.ContentTemplateSelector.SelectTemplate(rowData, contentPresenter);
                    comboBox = (ComboBox)dataTemplate.FindName("combobox", contentPresenter);
                            
                }

                
         }), System.Windows.Threading.DispatcherPriority.ApplicationIdle);
     }

        public childItem FindVisualChild<childItem>(DependencyObject obj)
 where childItem : DependencyObject
        {
            for (int i = 0; i < VisualTreeHelper.GetChildrenCount(obj); i++)
            {
                DependencyObject child = VisualTreeHelper.GetChild(obj, i);
                if (child != null && child is childItem)
                    return (childItem)child;
                else
                {
                    childItem childOfChild = FindVisualChild<childItem>(child);
                    if (childOfChild != null)
                        return childOfChild;
                }
            }
            return null;
        }

        private void sfdatagrid_CurrentCellValidating(object sender, CurrentCellValidatingEventArgs e) {
            Debug.WriteLine(string.Format("sfdatagrid_CurrentCellValidating: {0} {1}", e.Column.HeaderText, e.NewValue));
            if (e.Column.HeaderText == "City") {
                if (e.NewValue.Equals("Sydney")) {
                    e.IsValid = false;
                    e.ErrorMessage = string.Format("{0} is not a valid city", e.NewValue);
                }
            }
        }

        private void sfdatagrid_RowValidating(object sender, RowValidatingEventArgs e) {
            Model model = (Model)e.RowData;
            string error =  ((IDataErrorInfo)model).Error;
            if (!string.IsNullOrEmpty(error)) {
                e.IsValid = false;
                e.ErrorMessages.Add("Error", "Testing sfdatagrid_RowValidating error message");
            }

            //if (model.EmployeeName == "Sam") {
            //    e.IsValid = false;
            //    e.ErrorMessages.Add("Error", "Invalid name");
            //}
            Debug.WriteLine(string.Format("sfdatagrid_RowValidating: {0} {1}", model.EmployeeName, e.IsValid));
        }

        private void sfdatagrid_RowValidated(object sender, RowValidatedEventArgs e) {
            Model model = (Model)e.RowData;
            Debug.WriteLine(string.Format("sfdatagrid_RowValidated: {0}", model.EmployeeName));
        }

        private void combobox_SelectionChanged(object sender, System.Windows.Controls.SelectionChangedEventArgs e) {
            this.sfdatagrid.GetValidationHelper().SetCurrentRowValidated(false);
            //this.sfdatagrid.GetValidationHelper().SetCurrentCellValidated(false);
        }

        private void textbox_TextChanged(object sender, TextChangedEventArgs e) {
            Debug.WriteLine(string.Format("textbox_TextChanged: {0}", ((TextBox)sender).Text));
            this.sfdatagrid.GetValidationHelper().SetCurrentRowValidated(false);
            //this.sfdatagrid.GetValidationHelper().SetCurrentCellValidated(false);
        }

        private void sfdatagrid_CurrentCellEndEdit(object sender, CurrentCellEndEditEventArgs e) {
            Debug.WriteLine("sfdatagrid_CurrentCellEndEdit");
        }

        private void sfdatagrid_QueryRowHeight(object sender, Syncfusion.UI.Xaml.Grid.QueryRowHeightEventArgs e) {
            SfDataGrid grid = (SfDataGrid)sender;
            Model model = (Model)grid.GetRecordAtRowIndex(e.RowIndex);
            if (model != null || true) {
                Syncfusion.UI.Xaml.Grid.GridRowSizingOptions gridRowResizingOptions = new Syncfusion.UI.Xaml.Grid.GridRowSizingOptions();
                double height;
                this.sfdatagrid.GridColumnSizer.FontSize = 8;               
                if (this.sfdatagrid.GridColumnSizer.GetAutoRowHeight(e.RowIndex, gridRowResizingOptions, out height)) {
                    e.Height = height;
                    e.Handled = true;
                }
            }
        }
    }

    public class GridCellEditTemplateSelector : DataTemplateSelector
    {

        public override DataTemplate SelectTemplate(object item, DependencyObject container)
        {
            var editor = (item as Model);

            if (editor.EmployeeId % 2 == 0)
            {
                return Application.Current.MainWindow.Resources["categoryDropdownTemplate"] as DataTemplate;
            }
            else
            {
                return Application.Current.MainWindow.Resources["textboxtemplate"] as DataTemplate;
            }
        }
    }

    //private void cellTypeBTN_Click(object sender, RoutedEventArgs e)
    //{
    //    int rowIndex = int.MinValue;
    //    int columnIndex = int.MinValue;
    //    if(! int.TryParse(this.rowTxT.Text, out rowIndex))
    //    {
    //        MessageBox.Show("Enter Row index");
    //    }
    //    if(! int.TryParse(this.colTxT.Text, out columnIndex))
    //    {
    //        MessageBox.Show("Enter Column index");
    //    }

    //    if (rowIndex != int.MinValue && columnIndex != int.MinValue)
    //    {
    //        int recordIndex = this.sfdatagrid.ResolveToRecordIndex(rowIndex);

    //       // this.sfdatagrid.GetRowGenerator();
    //        var rowGenerator = this.sfdatagrid.GetRowGenerator() as RowGenerator;
    //        var dataRowBase = rowGenerator.Items.FirstOrDefault(row => ((row.RowIndex - 1) == recordIndex));
    //        if (dataRowBase != null)
    //        {
    //            var propertyinfo = dataRowBase.GetType().GetProperty("VisibleColumns", BindingFlags.Instance |
    //                        BindingFlags.NonPublic |
    //                        BindingFlags.Public);
    //            var columns = propertyinfo.GetValue(dataRowBase) as List<DataColumnBase>;

    //            foreach (var dataColumn in columns.Where(column => column.Renderer != null && column.GridColumn != null))
    //            {
    //                if (dataColumn.GridColumn.MappingName.Equals(sfdatagrid.Columns[columnIndex].MappingName))
    //                {
    //                    if (dataColumn.Renderer.GetType() == typeof(GridCellTextBoxRenderer))
    //                    {
    //                        MessageBox.Show(((GridCellTextBoxRenderer)dataColumn.Renderer).EditorType.ToString());
    //                    }
    //                    else if (dataColumn.Renderer.GetType() == typeof(GridCellTemplateRenderer))
    //                    {
    //                        var templateColumn = dataRowBase.VisibleColumns.FirstOrDefault(c => c.ColumnIndex == 0);

    //                        if (templateColumn == null)
    //                            return;
    //                        var templateCell = templateColumn.ColumnElement as GridCell;

    //                        if (templateCell == null)
    //                            return;

    //                        ContentPresenter contentPresenter = this.FindVisualChild<ContentPresenter>(templateCell);

    //                        DataTemplate dataTemplate = contentPresenter.ContentTemplateSelector.SelectTemplate(dataRowBase.RowData,contentPresenter);
    //                        ComboBox comboBox = (ComboBox)dataTemplate.FindName("combobox", contentPresenter);

    //                    }

    //                }
    //            }
    //         }
    //      }

    //    }


}


   

   
         
   

