﻿using Syncfusion.Windows.Shared;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.ComponentModel.DataAnnotations;
using System.Diagnostics;

namespace SfDataGridDemo
{
   public class Model : INotifyPropertyChanged, IDataErrorInfo, IEditableObject {
        private int _EmployeeId;
        public int EmployeeId
        {
            get { return _EmployeeId; }
            set
            {
                _EmployeeId = value;
                OnPropertyChanged("EmployeeId");
            }
        }

        private string _EmployeeName;
        //[StringLength(20, ErrorMessage = "EmployeeName must be less than 20 characters long")]
        public string EmployeeName
        {
            get { return _EmployeeName; }
            set
            {
                _EmployeeName = value;
                OnPropertyChanged("EmployeeName");
            }
        }

        private string _City;
        public string City
        {
            get { return _City; }
            set
            {
                _City = value;
                OnPropertyChanged("City");
            }
        }

        private string _MailId;
        public string MailId
        {
            get { return _MailId; }
            set
            {
                _MailId = value;
                OnPropertyChanged("MailId");
            }
        }

        [Display(AutoGenerateField = false)]
        public string Error {
            get {
                string error = string.Empty;
                if (EmployeeName.Equals("Sam")) {
                    error = string.Format("{0} is an invalid EmployeeName", EmployeeName);
                }
                else if (EmployeeId == 2) {
                    error = "Invalid employe ID";
                }
                Debug.WriteLine(string.Format("IErrorDataInfo.Error - EmployeeId {0}", EmployeeId, error));
                return error;
            }
        }

        public string this[string columnName] {
            get {
                string error = string.Empty;
                
                switch (columnName) {
                    case "EmployeeName":
                        if (EmployeeName.Equals("Sam")) {
                            error = string.Format("{0} is an invalid EmployeeName", EmployeeName);
                        }
                        break;
                    case "City":
                        if (City.Equals("Sydney")) {
                            error = string.Format("{0} is not a valid city", City);
                        }
                        break;
                    case "MailId":
                        if (MailId.Equals("Sam")) {
                            error = string.Format("{0} is an invalid City", MailId);
                        }
                        break;
                }
                Debug.WriteLine(string.Format("IErrorDataInfo.this {0} {1}", columnName, error));
                return error;
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
        public void OnPropertyChanged(string PropertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(PropertyName));
        }

        void IEditableObject.BeginEdit() {
            Debug.WriteLine("BeginEdit");
        }

        void IEditableObject.EndEdit() {
            Debug.WriteLine("EndEdit");
        }

        void IEditableObject.CancelEdit() {
            Debug.WriteLine("CancelEdit");
        }
    }
}

      
    

