﻿using Syncfusion.Windows.Shared;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SfDataGridDemo
{
    public class ViewModel : INotifyPropertyChanged
    {
        private ObservableCollection<Model> _EmployeeDetails;
        public ObservableCollection<Model> EmployeeDetails
        {
            get { return _EmployeeDetails; }
            set
            {
                _EmployeeDetails = value;
                OnPropertyChanged("EmployeeDetails");
            }
        }

        private ObservableCollection<string> comboBoxItemSource;
        public ObservableCollection<string> ComboBoxItemSource
        {
            get { return comboBoxItemSource; }
            set
            {
                comboBoxItemSource = value;
                OnPropertyChanged("ComboBoxItemSource");
            }
        }
        public ViewModel()
        {
            GetEmployeeDetails();
            GetComboSource();
        }
        public void GetEmployeeDetails()
        {
            EmployeeDetails = new ObservableCollection<Model>();
            EmployeeDetails.Add(new Model() { EmployeeId = 1, EmployeeName = "John", City = "Chennai", MailId = "john1@gmail.com" });
            EmployeeDetails.Add(new Model() { EmployeeId = 2, EmployeeName = "Sam", City = "Chennai", MailId = "sam2@gmail.com" });
            EmployeeDetails.Add(new Model() { EmployeeId = 3, EmployeeName = "Swathi", City = "Vellore", MailId = "swathi3@gmail.com" });
            EmployeeDetails.Add(new Model() { EmployeeId = 4, EmployeeName = "Guhan", City = "Chennai", MailId = "guhan4@gmail.com" });
            EmployeeDetails.Add(new Model() { EmployeeId = 5, EmployeeName = "Monisha", City = "Madurai", MailId = "monisha5@gmail.com" });
            EmployeeDetails.Add(new Model() { EmployeeId = 6, EmployeeName = "Ram", City = "Vellore", MailId = "ram6@gmail.com" });
            EmployeeDetails.Add(new Model() { EmployeeId = 7, EmployeeName = "Sridhar", City = "Chennai", MailId = "Sridhar7@gmail.com" });
            EmployeeDetails.Add(new Model() { EmployeeId = 8, EmployeeName = "Mano", City = "Chennai", MailId = "Mano8@gmail.com" });
            EmployeeDetails.Add(new Model() { EmployeeId = 9, EmployeeName = "Hema", City = "Madurai", MailId = "hema9@gmail.com" });
            EmployeeDetails.Add(new Model() { EmployeeId = 10, EmployeeName = "Kasthuri", City = "Chennai", MailId = "kasthuri10@gmail.com" });
            EmployeeDetails.Add(new Model() { EmployeeId = 11, EmployeeName = "Jagan", City = "Madurai", MailId = "jagan11@gmail.com" });
            EmployeeDetails.Add(new Model() { EmployeeId = 12, EmployeeName = "Gowtham", City = "Vellore", MailId = "gowtham12@gmail.com" });
            EmployeeDetails.Add(new Model() { EmployeeId = 13, EmployeeName = "Kalpana", City = "Chennai", MailId = "kalpana13@gmail.com" });
            EmployeeDetails.Add(new Model() { EmployeeId = 14, EmployeeName = "Jeeva", City = "Madurai", MailId = "jeeva14@gmail.com" });
            EmployeeDetails.Add(new Model() { EmployeeId = 15, EmployeeName = "Samuel", City = "Vellore", MailId = "samuel15@gmail.com" });
            EmployeeDetails.Add(new Model() { EmployeeId = 16, EmployeeName = "Riya", City = "Chennai", MailId = "riya16@gmail.com" });
            EmployeeDetails.Add(new Model() { EmployeeId = 17, EmployeeName = "Pavithra", City = "Madurai", MailId = "pavithra17@gmail.com" });
            EmployeeDetails.Add(new Model() { EmployeeId = 18, EmployeeName = "Kumar", City = "Vellore", MailId = "kumar18@gmail.com" });
        }
        public void GetComboSource()
        {
            ComboBoxItemSource = new ObservableCollection<string>();
            foreach (var data in EmployeeDetails)
                ComboBoxItemSource.Add(data.EmployeeName.ToString());
        }

        public event PropertyChangedEventHandler PropertyChanged;
        public void OnPropertyChanged(string PropertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(PropertyName));
        }
    }
}
            
        
     

